unit lfsc_ole_1;
interface
uses
  lfsc_ole_0,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_Init: TEdit;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Edit_1C8_Name: TEdit;
    CheckBox1: TCheckBox;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    Label_YesConnect: TLabel;
    Label3: TLabel;
    Panel4: TPanel;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    ListBox1: TListBox;
    SpeedButton3: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure TreeView1Changing(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure TreeView1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    s1C8_ole : Variant; //  1Cv8

  end;

var
  Form1: TForm1;


//,       Excel
function Tree_CopyToExcel(sHead : string; ListTree : TTreeView) : integer;


implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  //
  s1C8_ole:=UnAssigned;
  Edit_1C8_Name.Text:='V8.Application';
  Edit_Init.Text:='File=F:\1Cv8.DB\HomeLib';
  TreeView1.Items.Clear;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  s1C8_ole:=UnAssigned;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  s1C8_ole:=UnAssigned;
  Label_YesConnect.Visible:=false;
  TreeView1.Items.Clear;
  ListBox1.Items.Clear;
  //  1Cv8
  s1C8_ole:=ConnectTo1C8_Application(Trim(Edit_1C8_Name.Text),Trim(Edit_Init.Text),CheckBox1.Checked);
  if YesLinkToVariant(s1C8_ole) then begin
     Label_YesConnect.Visible:=true;
  end
  else begin
     ShowMessage('');
  end;
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin
     //  1Cv8
     s1C8_ole.Visible:=CheckBox1.Checked;
  end;
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
//    
//   
Var
  Sel_ole, //   
  SbCnt_ole  : Variant; //   "."
  i,j,
  iNextTree,
  Lev,iLev : integer;
  S1, S2,
  idThis1,idParent1 : string;
  idThis2,idParent2 : string;

begin
  SbCnt_ole:=UnAssigned;
  Sel_ole:=UnAssigned;
  TreeView1.Items.Clear;
  ListBox1.Items.Clear;

  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin

     //      -  ""
     SbCnt_ole:=s1C8_ole..;
     //    
     //Sel_ole := SbCnt_ole.();
     Sel_ole := SbCnt_ole.();

     //  
     while Sel_ole.() do
      begin
        if Sel_ole. then begin
          //  
          ListBox1.Items.Add(Trim(Sel_ole.)+' '+Trim(Sel_ole..){+' '+Trim(Sel_ole.)}+' '+Trim(Sel_ole.));
        end;
     end;

     // ""     
     ListBox1.Items.Add('0 -1    : ');

     //    ,
     //       TTreeView
     Convert_List_to_Tree(' ', '0',ListBox1.Items);

     //     
     ListBox1.Items.SaveToFile(ExtractFilePath(ParamStr(0))+'~TreeGrp.txt');
     ListBox1.Items.Clear; // 

     //         TTreeView
     TreeView1.LoadFromFile(ExtractFilePath(ParamStr(0))+'~TreeGrp.txt');

     //  
     TreeView1.FullExpand;

  end
  else begin
     ShowMessage('     1Cv8 !');
  end;
end;


procedure TForm1.TreeView1Click(Sender: TObject);
Var
  idGrp : string;
  Sel_ole, //   
  TekEl,
  SbCnt_ole  : Variant; //   "."
begin
  //    ( )
  ListBox1.Items.Clear;
  if TreeView1.Selected <> NIL then begin
     //    - 

     //    (1-   )
     idGrp:=sp_GetWordFromString(' ',TreeView1.Selected.Text,1);

     if length(idGrp)>0 then begin

        //    ".;"
        SbCnt_ole:=s1C8_ole..;

        //    
        TekEl:=SbCnt_ole.(idGrp);

        //    
        Sel_ole := SbCnt_ole.(TekEl);

        //  
        while Sel_ole.() do
         begin
           if not Sel_ole. then begin
             //   ( )
             //    
             ListBox1.Items.Add(Trim(Sel_ole.)+' '+Trim(Sel_ole..)+' '+Trim(Sel_ole.));
           end;
        end;
        
     end;
  end;
end;


procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  Tree_CopyToExcel(': ', TreeView1);
end;


procedure TForm1.TreeView1Changing(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
end;




//****************************************************
//****************************************************
//****************************************************


function Tree_CopyToExcel(sHead : string; ListTree : TTreeView) : integer;
//,       Excel
//sHead    -  ( )
//ListTree -  TTreeView
//  - -   ()
//(c) Sergey Popov, Usinsk, Komi
Var
  Lev,MaxLevel,iLev,
  NumLine, NumCol,NumLineLast,NumLineFirst,
  i123,j,i,k : integer;
  Excel : OleVariant;
  ListExcel,ActiveWB : Variant;
begin
  Result:=0;
  if ListTree<>NIL then begin

     //--------------------
     // Excel     1- 
     Excel:=sp_ExecExcel(1,1);
     ActiveWB:=Excel.ActiveWorkbook;
     ListExcel:=ActiveWB.WorkSheets[1];
     //--------------------

     sHead:=Trim(sHead);
     MaxLevel:=0;
     NumLine:=1;
     NumCol:=1;

     //--------------------
     //  
     ListExcel.Cells[NumLine,NumCol].Value := #39+'Date : '+DateTimeToStr(NOW);
     //--------------------

     NumLine:=NumLine+1;
     if Length(sHead)>0 then begin
        //--------------------
        // 
        NumLine:=NumLine+1;
        PutToCellInExcel(ListExcel,NumLine,NumCol,1,0,#39+sHead);
        NumLine:=NumLine+1;
        //--------------------
     end;
     Result:=NumLine;
     NumLineFirst:=0;
     NumLineLast:=0;
     MaxLevel:=0;
     if ListTree.Items.Count>0 then begin
        //--------------------
        // 
        i:=-1;
        while i<(ListTree.Items.Count-1) do
         begin
           i:=i+1;
           Lev:=ListTree.Items[i].Level;
           NumCol:=Lev+1;
           if MaxLevel < Lev then MaxLevel := Lev;
           NumLine:=NumLine+1;
           if i=0 then NumLineFirst:=NumLine;
           ListExcel.Cells[NumLine,NumCol].Value := #39+ListTree.Items[i].Text;
           ListExcel.Cells[NumLine,NumCol].Borders[4].LineStyle:=3; //1
           Application.ProcessMessages;
        end;
        //--------------------

        NumLineLast:=NumLine;
        Result:=NumLine;
        MaxLevel:=MaxLevel+1;

        //--------------------
        //     2 (  )
        for i:=1 to MaxLevel do
         begin
           ListExcel.Columns[i].ColumnWidth := 2;
        end;
        //--------------------

        //--------------------
        //    ( )
        i123:=0;
        i:=NumLineFirst;
        while i<NumLineLast do
         begin
           i:=i+1;
           i123:=i123+1;
           j:=1;
           while j<MaxLevel do
            begin
              j:=j+1;
              if Length(Trim(ListExcel.Cells[i,j].Value))>0 then begin
                 k:=i+1;
                 while k>1 do
                  begin
                    k:=k-1;
                    if Length(Trim(ListExcel.Cells[k,j-1].Value))<=0 then begin
                       ListExcel.Cells[k,j].Borders[1].LineStyle:=3;
                    end
                    else begin
                       k:=-1;
                    end;
                 end;
                 j:=MaxLevel+1;
              end;
           end;
           Application.ProcessMessages;
        end;
        //--------------------

     end;
  end;
end;






end.




